#!/usr/bin/env python3
#
# Copyright (c) 2024 Stormux
# Copyright (c) 2010-2012 The Orca Team
# Copyright (c) 2012 Igalia, S.L.
# Copyright (c) 2005-2010 Sun Microsystems Inc.
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the
# Free Software Foundation, Inc., Franklin Street, Fifth Floor,
# Boston MA  02110-1301 USA.
#
# Fork of Orca Screen Reader (GNOME)
# Original source: https://gitlab.gnome.org/GNOME/orca

from macaroon.playback import *
import utils

sequence = MacroSequence()

#sequence.append(WaitForDocLoad())
sequence.append(PauseAction(5000))

sequence.append(utils.StartRecordingAction())
sequence.append(KeyComboAction("<Control>Home"))
sequence.append(utils.AssertPresentationAction(
    "1. Top of file",
    ["BRAILLE LINE:  'MathML mfenced test cases'",
     "     VISIBLE:  'MathML mfenced test cases', cursor=1",
     "SPEECH OUTPUT: 'MathML mfenced test cases'"]))

sequence.append(utils.StartRecordingAction())
sequence.append(KeyComboAction("Down"))
sequence.append(utils.AssertPresentationAction(
    "2. Line Down",
    ["BRAILLE LINE:  'math'",
     "     VISIBLE:  'math', cursor=0",
     "SPEECH OUTPUT: 'left paren.'",
     "SPEECH OUTPUT: 'a comma.'",
     "SPEECH OUTPUT: 'b comma.'",
     "SPEECH OUTPUT: 'c comma.'",
     "SPEECH OUTPUT: 'd comma.'",
     "SPEECH OUTPUT: 'e.'",
     "SPEECH OUTPUT: 'right paren'"]))

sequence.append(utils.StartRecordingAction())
sequence.append(KeyComboAction("Down"))
sequence.append(utils.AssertPresentationAction(
    "3. Line Down",
    ["BRAILLE LINE:  'math'",
     "     VISIBLE:  'math', cursor=0",
     "SPEECH OUTPUT: 'left brace.'",
     "SPEECH OUTPUT: 'a semicolon.'",
     "SPEECH OUTPUT: 'b semicolon.'",
     "SPEECH OUTPUT: 'c semicolon.'",
     "SPEECH OUTPUT: 'd semicolon.'",
     "SPEECH OUTPUT: 'e.'",
     "SPEECH OUTPUT: 'right brace'"]))

sequence.append(utils.StartRecordingAction())
sequence.append(KeyComboAction("Down"))
sequence.append(utils.AssertPresentationAction(
    "4. Line Down",
    ["BRAILLE LINE:  'math'",
     "     VISIBLE:  'math', cursor=0",
     "SPEECH OUTPUT: 'left brace.'",
     "SPEECH OUTPUT: 'a semicolon.'",
     "SPEECH OUTPUT: 'b semicolon.'",
     "SPEECH OUTPUT: 'c comma.'",
     "SPEECH OUTPUT: 'd comma.'",
     "SPEECH OUTPUT: 'e.'",
     "SPEECH OUTPUT: 'right brace'"]))

sequence.append(utils.StartRecordingAction())
sequence.append(KeyComboAction("Down"))
sequence.append(utils.AssertPresentationAction(
    "5. Line Down",
    ["BRAILLE LINE:  'End of test'",
     "     VISIBLE:  'End of test', cursor=1",
     "SPEECH OUTPUT: 'End of test'"]))

sequence.append(utils.AssertionSummaryAction())
sequence.start()
