#!/usr/bin/env python3
#
# Copyright (c) 2024 Stormux
# Copyright (c) 2010-2012 The Orca Team
# Copyright (c) 2012 Igalia, S.L.
# Copyright (c) 2005-2010 Sun Microsystems Inc.
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the
# Free Software Foundation, Inc., Franklin Street, Fifth Floor,
# Boston MA  02110-1301 USA.
#
# Fork of Orca Screen Reader (GNOME)
# Original source: https://gitlab.gnome.org/GNOME/orca

"""Test of sayAll."""

from macaroon.playback import *
import utils

sequence = MacroSequence()

#sequence.append(WaitForDocLoad())
sequence.append(PauseAction(5000))

sequence.append(utils.StartRecordingAction())
sequence.append(KeyComboAction("KP_Add"))
sequence.append(utils.AssertPresentationAction(
    "1. KP_Add to do a SayAll",
    ["SPEECH OUTPUT: 'On weaponry:'",
     "SPEECH OUTPUT: 'NOBODY expects the Spanish Inquisition!'",
     "SPEECH OUTPUT: 'Our chief weapon is surprise.'",
     "SPEECH OUTPUT: 'Surprise and fear.'",
     "SPEECH OUTPUT: 'Fear and surprise.'",
     "SPEECH OUTPUT: 'Our two weapons are fear and surprise.'",
     "SPEECH OUTPUT: 'And ruthless efficiency.'",
     "SPEECH OUTPUT: 'Our three weapons are fear, surprise, and ruthless efficiency.'",
     "SPEECH OUTPUT: 'And an almost fanatical devotion to the Pope.'",
     "SPEECH OUTPUT: 'Our four.'",
     "SPEECH OUTPUT: 'No.'",
     "SPEECH OUTPUT: 'Amongst our weapons.'",
     "SPEECH OUTPUT: 'Amongst our weaponry, are such elements as fear, surprise.'",
     "SPEECH OUTPUT: 'I'll come in again.'",
     "SPEECH OUTPUT: 'NOBODY expects the Spanish Inquisition!'",
     "SPEECH OUTPUT: 'Amongst our weaponry are such diverse elements as: fear, surprise, ruthless efficiency, an almost fanatical devotion to the Pope, and nice red uniforms - Oh damn!'",
     "SPEECH OUTPUT: 'On old ladies:'",
     "SPEECH OUTPUT: 'Now old lady, you have one last chance.'",
     "SPEECH OUTPUT: 'Confess the heinous sin of heresy, reject the works of the ungodly.'",
     "SPEECH OUTPUT: 'Two last chances.'",
     "SPEECH OUTPUT: 'And you shall be free.'",
     "SPEECH OUTPUT: 'Three last chances.'",
     "SPEECH OUTPUT: 'You have three last chances, the nature of which I have divulged in my previous utterance.'",
     "SPEECH OUTPUT: 'On castle decor:'",
     "SPEECH OUTPUT: 'Hm! She is made of harder stuff!'",
     "SPEECH OUTPUT: 'Cardinal Fang!'",
     "SPEECH OUTPUT: 'Fetch the COMFY CHAIR!'"]))

sequence.append(utils.AssertionSummaryAction())
sequence.start()
